Subject: Re: bug#72210: 31.0.50; Feature request: multi-category support in `icomplete-fido-kill'.

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 Sep 2024 10:42:41 +0300

> Cc: [email-masked]
> From: Fernando de Morais <[email-masked]>
> Date: Mon, 02 Sep 2024 13:23:19 -0300
> 
> Stefan Monnier <[email-masked]> writes:
> 
> >> `icomplete-fido-kill' works very well, but cannot handle the deletion of
> >> files or killing buffers when they are behind a multi-category
> >> ``situation''.  Add this would be useful for those of us that combine
> >> `icomplete' with, e.g., `consult-buffer'.
> >
> > Can you provide a recipe?  I'm not sufficiently familiar with that code
> > to really understand the problem you're facing.
> 
> Sure!
> 
> Please, install the `consult' package and, in an emacs -Q session,
> evaluate the following:
> 
> #+begin_src emacs-lisp
> (progn
>   (package-initialize)
>   (load-library "consult")
>   (icomplete-vertical-mode t)
>   (keymap-set icomplete-minibuffer-map "C-k" 'icomplete-fido-kill))
> #+end_src
> 
> - Then, ``M-x consult-buffer'';
> - Type *M (this should turn the `*Messages*' buffer the current
>   candidate);
> - Then ``C-k''
> 
> The following message should appear in the minibuffer:
> 
> [Sorry, don’t know how to kill things for ‘multi-category’]
> 
> The same happens when we try to use `icomplete-fido-kill' in files
> listed by `consult-buffer'.
> 
> The expected result would be for `icomplete-fido-kill' to work normally,
> killing the buffer, even though it is listed by `consult-buffer'.
> 
> >> What follows is just the ``hacky'' approach that's currently being used
> >> in my init:
> >
> > Any chance you can make it a patch against `icomplete.el`?
> 
> Follows attached!  This is my first patch, so I might have made
> mistakes, but I'm here to adjust whatever you deem necessary.

Stefan, any comments on the patch, or should I install it?